#include<bits/stdc++.h>
using namespace std;
int o,a,b,ab,n,t[100000], zbiro,zbira,zbirb,zbirab;
string pacijenti[100000];
int main()
{
  zbiro=0;
  zbira=0;
  zbirb=0;
  zbirab=0;

  cin >> n;
  cin >> o >> a >> b >> ab;
  for(int i=0; i<n; i++)
  {
    cin >> pacijenti[i] >> t[i];
    if(pacijenti[i]=="O")
    {
      zbiro=zbiro+t[i];
    }

    if(pacijenti[i]=="A")
    {
      zbira=zbira+t[i];
    }

      if(pacijenti[i]=="B")
    {
      zbirb=zbirb+t[i];
    }

      if(pacijenti[i]=="AB")
    {
      zbirab=zbirab+t[i];
    }
  }
  int pacijenti_krv=0;
  int krv=0;

  pacijenti_krv=(zbiro*3)+(zbira*2)+(zbirb*2)+zbirab;
  krv=o*3+a*2+b*2+ab;

  if(pacijenti_krv<krv)
  {
    cout << "moguce" << endl;
    return 0;
  }
  else
  {
    cout << "nemoguce" << endl;
    return 0;
  }
  return 0;
  // o samo o
  // a moze a, o
  // b moze b, o
  // ab moze bilo sta


}